;***************************************************
; Rotor Organ with Leslie Rotating Speaker
;***************************************************

sr = 44100
kr  =  44100
ksmps =1
nchnls = 2

instr 1   ; Rotor Organ
idur  = p3
iamp  = p4 
ifqc  = cpspch(p5)
inh   = sr/2/ifqc
gasig init 0

      asrc    oscil iamp, ifqc, 2                       ; B3 source
      kenv    linseg   0, .05, 1, idur-.1, 1, .05, 0   ; envelope
      asrc=asrc * kenv
      gasig = asrc + gasig ; *kenv + gasig

endin

; Leslie Rotating Speaker
instr 2
  galeslie delayr .02, 1
           delayw gasig

; Acceleration
  kenv linseg p4, p3, p5

; Doppler Effect
  koscl oscil 1, kenv, 1, 0
  koscr oscil 1, kenv, 1, .5
  kdopl = .01-koscl*.0003
  kdopr = .012-koscr*.0003
  aleft deltapi kdopl
  aright deltapi kdopr

; Filter Effect
  kflosc = koscl * 8000 + 10000
  kfrosc = koscr * 8000 + 10000
  alfilt tone aleft, kflosc
  arfilt tone aright, kfrosc

; Amplitude Effect
  kalosc = koscl * .1 + 1
  karosc = koscr * .1 + 1

  outs     alfilt*kalosc, arfilt*karosc
endin