sr = 44100
kr = 44100
ksmps = 1
nchnls = 2

;---------------------------------------------------------------
; VCO with Sync
;---------------------------------------------------------------
           instr   11

idur       =       p3           ; Duration
iamp       =       p4           ; Amplitude
ifqc       =       cpspch(p5)   ; Frequency
ifqc2      =       ifqc*p6      ; Frequency of pseudo synched oscillator wrt base frequency
ifco       =       p7*ifqc/500  ; Filter cut-off frequency based, higher pitches get a higher cut off

krez       init    p8           ; krez is not changing
kfco       expseg  100+.01*ifco, .2*idur, ifco+100, .5*idur, ifco*.1+100, .3*idur, .001*ifco+100 ; Filter envelope
kamp       linseg  0, .01*idur, iamp, .2*idur, .8*iamp, .49*idur, .5*iamp, .2*idur, 0            ; Amp envelope

asaw2      init    0

apulse1    buzz    1, ifqc, sr/2/ifqc, 1          ; Band-limited impulse train
apulse2    buzz    1, ifqc2, sr/2/ifqc2, 1        ; Band-limited impulse train

asaw       integ   apulse1                        ; Integrate the pulse for a square wave

aamp1      oscili  1, ifqc,  3                    ; Turn on the gate in sync with the impulses
aamp2      oscili  1, ifqc2, 3

asaw2      =      (apulse1 + apulse2*aamp2*(1-aamp1))*(1.2-asaw2) + (1-ifqc/sr)*asaw2 ; Basically don't add two impulses
asaw3      =      1-asaw2

aout       rezzy   asaw3, kfco, krez

           outs    aout*kamp, aout*kamp

           endin

