sr = 44100
kr = 4410
ksmps = 10
nchnls = 2

instr 1
isc  =  .6   ; scalar chosen to match white noise amplitude

ksw  expseg 30, p3, 18000 ; sweep filter from 30Hz to 18000Hz

a1  init  0
a2  init  0
a3  init  0
a4  init  0
a5  init  0
a6  init  0
anz  trirand 30000  ; white noise
a1  =  .997 * a1 + isc * .029591 * anz
a2  =  .985 * a2 + isc * .032534 * anz
a3  =  .950 * a3 + isc * .048056 * anz
a4  =  .850 * a4 + isc * .090579 * anz
a5  =  .620 * a5 + isc * .108990 * anz
a6  =  .250 * a6 + isc * .255784 * anz
apnz  =  a1 + a2 + a3 + a4 + a5 + a6
apnz  butterbp apnz, ksw, ksw * .05    ; sweep filter
apnz  butterlp apnz, ksw * 1.2  ; remove high end which passes thru
   outs apnz, apnz
endin


; Pink Noise Instrument
       instr   2

idur   =       p3
iamp   =       p4
ifctab =       p5
iswrt  =       p6

krtrmp expseg  .025, idur/2, 2, idur/2, .0025

kfc    oscili  1, iswrt/idur*krtrmp, ifctab

isc    =       .6    ; scalar chosen to match white noise amplitude

anz   trirand  iamp*20  ; white noise

a1    pareq    anz, 625,   .7079, .707, 2
a2    pareq    a1,  1250,  .5011, .707, 2
a3    pareq    a2,  2500,  .3548, .707, 2
a4    pareq    a3,  5000,  .2512, .707, 2
a5    pareq    a4,  10000, .1778, .707, 2
apnz  pareq    a5,  20000, .1259, .707, 2

apnz  butterbp apnz, kfc, kfc*.05    ; sweep filter
      outs     apnz, apnz

      endin

